package com.ruoyi.bst.area.service.impl;

import java.util.Arrays;
import java.util.HashSet;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.ruoyi.bst.area.domain.AreaQuery;
import com.ruoyi.bst.area.mapper.AreaMapper;
import com.ruoyi.bst.area.service.AreaValidator;
import com.ruoyi.common.utils.collection.CollectionUtils;

@Service
public class AreaValidatorImpl implements AreaValidator {

    @Autowired
    private AreaMapper areaMapper;


    @Override
    public boolean canEdit(Long areaId) {
        return canOperate(Arrays.asList(areaId));
    }

    @Override
    public boolean canDeleteAll(List<Long> areaIds) {
        return canOperate(areaIds);
    }

    @Override
    public boolean canAddSubArea(Long areaId) {
        return canOperate(Arrays.asList(areaId));
    }

    // 是否可以操作运营区
    private boolean canOperate(List<Long> areaIds) {
        return canView(areaIds);
    }

    @Override
    public boolean canView(List<Long> areaIds) {
        if (CollectionUtils.isEmptyElement(areaIds)) {
            return true;
        }
        // 查询运营区ID
        AreaQuery query = new AreaQuery();
        query.setIds(areaIds);
        query.setScope(true);
        List<Long> ids = areaMapper.selectIdByQuery(query);
        // 判断运营区ID是否一致
        return new HashSet<>(ids).containsAll(areaIds);
    }





}
